# -*- coding: utf-8 -*-
"""
    ML04-1.py
    ~~~~~~~~~

    Model evaluation and diagnostics
    B(E)3M3UI - Artificial Intelligence

    :author: Petr Posik, Jiri Spilka, 2019

    FEE CTU in Prague
"""

import numpy as np
import pandas as pd
from sklearn import linear_model, metrics, svm, preprocessing, model_selection
from matplotlib import pyplot as plt

import plotting


def load_data_binary_classification():
    """Load 'auto-mpg.csv' and return the disp and hp columns as numpy arrays.
    """
    df = pd.read_csv('auto-mpg.csv', skipinitialspace=True,
                     names=['mpg', 'cyl', 'disp', 'hp', 'wgt', 'acc', 'year', 'orig', 'name'])
    X = df.xs(['disp', 'hp'], axis=1).values
    y = df.orig.values
    y[y > 1] = 0
    return X, y


# Load data
X, y = load_data_binary_classification()
print('\nThe dataset (X and y) size:')
print('X: ', X.shape)
print('y: ', y.shape)

# scale the data
sc = preprocessing.StandardScaler()
X = sc.fit_transform(X)

# FIXME Task 1: Implement metrics to measure model performance
raise NotImplementedError
# <YOUR CODE HERE>
# clf = ... classifier
# clf.fit, clf.predict

# FIXME Tasks 2-3: ROC curves
# # Setup the list of models
models = []

# Setup a classifier
# They can be even pipelines with basis expansion, etc.
clf = svm.SVC(kernel='rbf', gamma=1, probability=True)
models.append({'clf': clf, 'descr': 'SVM1', 'color': 'b'})

raise NotImplementedError
# <YOUR CODE HERE>

# use the models, fit them and plot ROC
plotting.plot_roc(models, X, y, X, y)

# FIXME Tasks 4-5: Model evaluation train/test split

raise NotImplementedError
# <YOUR CODE HERE>

print('\nShapes of training and testing X:')
print(Xtr.shape)
print(Xtst.shape)
print('Shapes of training and testing y:')
print(ytr.shape)
print(ytst.shape)

# Fit the model to training data, validate on test data
raise NotImplementedError
# <YOUR CODE HERE>

print('\nThe training and testing accuracies when simple split is used:')
print('train acc:', acc_tr)
print('test  acc:', acc_tst)

# FIXME Tasks 6-10: Cross-validation and manual tuning
# Use 5-fold cross-validation
# Play with SVM parameters and try to understand them
folds = 5
raise NotImplementedError
# <YOUR CODE HERE>

print("\n{:d}-cross-validation ACC: {:.2f} (+/- {:.2f})".format(folds, accuracies.mean(), accuracies.std()))
print('accuracies:', accuracies)

# FIXME Tasks 11-13: Cross-validation and grid search
raise NotImplementedError
# <YOUR CODE HERE>

parameters = {
    'C': ...,
    'gamma': ...
}

print('\nTUNING PARAMETERS:\n')
for param_name in sorted(parameters.keys()):
    print(param_name, parameters[param_name])

print("\nAFTER TUNING: ")
print('Best parameters found:')
print(clf.best_params_)
print('CV score for the best parameter values:')
print(clf.best_score_)

# Print the scores of the TUNED classifier for training and testing data
raise NotImplementedError
# <YOUR CODE HERE>

print('\nThe training and testing accuracies for TUNED classifier:')
print('train acc:', acc_tr)
print('test  acc:', acc_tst)
